/**
 * Created with WebStorm.
 * User: gp
 * Date: 16-2-3
 *
 */

import React, { Component } from 'react';
//import immutable from 'immutable'
import clone from 'clone';


class NativeNavBar extends Component {

    constructor(props, context) {
        super(props, context);
        //通知native改变
        //this.noticeNative();
    }

    render() {
        return (
            <div className="navbar-native"></div>
        )
    }

    componentDidMount(){
        this.noticeNative();
    }

   _wrapConfig(props,processFn){
	   
	   let pageId = props.scope.pageId;
	   //let cfg = immutable.fromJS({}).mergeDeep(props.navOpt).toJS();
       let cfg = clone(props.navOpt);
       let right = cfg.right;
       if(cfg.onBackClick){
           cfg.onBackClick = 'executePageClick("onBackClick",'+pageId+')';
       }
       if(cfg.onCloseClick){
           cfg.onCloseClick = 'executePageClick("onCloseClick",'+pageId+')';
       }
       
       if(right){
    	   let comps = right.item;
    	   if(Array.isArray(comps)){
    		  comps.forEach(function(item,idx){
    			 if(item.onClick){
    				 item.onClick = 'executePageClick("right/item/'+idx+'/onClick",'+pageId+')';
    			 } 
    		  }) 
    	   }else if(comps.onClick){
              comps.onClick = 'executePageClick("right/item/onClick",'+pageId+')';
           }
       }
       if(processFn){processFn(cfg)}

       return cfg;
   }


    noticeNative(){
       var cfg = this._wrapConfig(this.props);
       cordova.exec(
            function(info) {},
            function(error) {},
            'TopBar',
            'configNavigationBar',
            [cfg])
    }
    
    //返回上一页,主要给android返回物理键使用
    back(){
        cordova.exec(
            function(info) {},
            function(error) {},
            'TopBar',
            'back',
            [])
    }

}

export default NativeNavBar;
